Subject: Re: bug#68415: User's shepherd services defined in guix home config can not start after guix pull.

From: Feng Shu <[email-masked]>
Date: Tue, 16 Jan 2024 20:44:31 +0800

Sergey Trofimov <[email-masked]> writes:

> Feng Shu <[email-masked]> writes:
>
>> After I guix pull, services defined in guix home config can no
>> start:
>>
>> -------------------------
>> 服务 root 已启动。
>> WARNING: Use of `load' in declarative module (#{ g117}#).  Add
>> #:declarative? #f to your define-module invocation.
>> unbound-variable(#f "Unbound variable: ~S" (service) #f)
>>
>> Some deprecated features have been used.  Set the environment
>> variable GUILE_WARN_DEPRECATED to "detailed" and rerun the
>> program to get more information.  Set it to "no" to suppress
>> this message.
>> Creating XDG user directories... done
>> Comparing
>> /gnu/store/bfkgfz1sm9q75jyn56pav2kmwl48i7w8-home/profile/share/fonts
>> and
>>           /gnu/store/bfkgfz1sm9q75jyn56pav2kmwl48i7w8-home/profile/share/fonts...
>> done (same)
>> Evaluating on-change gexps.
>>
>> -----------
>>
>> When I run command: herd status, show error:
>>
>> feng@Guix ~$ herd status
>> error: connect: /run/user/1000/shepherd/socket: No such file or
>> directory
>
> Have you tried debugging it? Is your home shepherd running? Do you see

I tried, but I do not know why: unbound-variable service

The below code run have problem, and I think shepherd is not run, for 
'ps aux |grep shepherd' can not found info.

(define xautolock-service
  (shepherd-service
   (provision '(xautolock))
   (documentation "Run 'xautolock'")
   (start #~(make-forkexec-constructor
             (list #$(file-append xautolock "/bin/xautolock")
                   "-detectsleep")))
   (stop #~(make-kill-destructor))))

...

     (service
      home-syncthing-service-type)

     (service
      home-shepherd-service-type
      (home-shepherd-configuration
       (shepherd shepherd)
       (services
        (list xautolock-service))))

> shepherd mentions in ~/.guix-home/on-first-login?

> Have you tried restarting your system?

Restart system no effect.

--